package com.sundot.airport.web.controller.system;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.StrUtil;
import com.sundot.airport.common.annotation.Log;
import com.sundot.airport.common.constant.UserConstants;
import com.sundot.airport.common.core.controller.BaseController;
import com.sundot.airport.common.core.domain.AjaxResult;
import com.sundot.airport.common.core.domain.entity.SysDept;
import com.sundot.airport.common.enums.BusinessType;
import com.sundot.airport.common.enums.DeptTypeEnum;
import com.sundot.airport.common.utils.StringUtils;
import com.sundot.airport.system.service.ISysDeptService;
import org.apache.commons.lang3.ArrayUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.*;
import java.util.stream.Collectors;

/**
 * 部门信息
 *
 * @author ruoyi
 */
@RestController
@RequestMapping("/system/dept")
public class SysDeptController extends BaseController {
    @Autowired
    private ISysDeptService deptService;

    /**
     * 获取部门列表
     */
    @PreAuthorize("@ss.hasPermi('system:dept:list')")
    @GetMapping("/list")
    public AjaxResult list(SysDept dept) {
        List<SysDept> depts = deptService.selectDeptList(dept);
        return success(depts);
    }

    /**
     * 查询部门列表（排除节点）
     */
    @PreAuthorize("@ss.hasPermi('system:dept:list')")
    @GetMapping("/list/exclude/{deptId}")
    public AjaxResult excludeChild(@PathVariable(value = "deptId", required = false) Long deptId) {
        List<SysDept> depts = deptService.selectDeptList(new SysDept());
        depts.removeIf(d -> d.getDeptId().intValue() == deptId || ArrayUtils.contains(StringUtils.split(d.getAncestors(), ","), deptId + ""));
        return success(depts);
    }

    /**
     * 根据部门编号获取详细信息
     */
    @PreAuthorize("@ss.hasPermi('system:dept:query')")
    @GetMapping(value = "/{deptId}")
    public AjaxResult getInfo(@PathVariable Long deptId) {
        deptService.checkDeptDataScope(deptId);
        return success(deptService.selectDeptById(deptId));
    }

    /**
     * 新增部门
     */
    @PreAuthorize("@ss.hasPermi('system:dept:add')")
    @Log(title = "部门管理", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@Validated @RequestBody SysDept dept) {
        if (!deptService.checkDeptNameUnique(dept)) {
            return error("新增部门'" + dept.getDeptName() + "'失败，部门名称已存在");
        }
        dept.setCreateBy(getUsername());
        return toAjax(deptService.insertDept(dept));
    }

    /**
     * 修改部门
     */
    @PreAuthorize("@ss.hasPermi('system:dept:edit')")
    @Log(title = "部门管理", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@Validated @RequestBody SysDept dept) {
        Long deptId = dept.getDeptId();
        deptService.checkDeptDataScope(deptId);
        if (!deptService.checkDeptNameUnique(dept)) {
            return error("修改部门'" + dept.getDeptName() + "'失败，部门名称已存在");
        } else if (dept.getParentId().equals(deptId)) {
            return error("修改部门'" + dept.getDeptName() + "'失败，上级部门不能是自己");
        } else if (StringUtils.equals(UserConstants.DEPT_DISABLE, dept.getStatus()) && deptService.selectNormalChildrenDeptById(deptId) > 0) {
            return error("该部门包含未停用的子部门！");
        }
        dept.setUpdateBy(getUsername());
        return toAjax(deptService.updateDept(dept));
    }

    /**
     * 删除部门
     */
    @PreAuthorize("@ss.hasPermi('system:dept:remove')")
    @Log(title = "部门管理", businessType = BusinessType.DELETE)
    @DeleteMapping("/{deptId}")
    public AjaxResult remove(@PathVariable Long deptId) {
        if (deptService.hasChildByDeptId(deptId)) {
            return warn("存在下级部门,不允许删除");
        }
        if (deptService.checkDeptExistUser(deptId)) {
            return warn("部门存在用户,不允许删除");
        }
        deptService.checkDeptDataScope(deptId);
        return toAjax(deptService.deleteDeptById(deptId));
    }

    @PostMapping("/teamList")
    public AjaxResult teamList(@RequestBody SysDept dept) {
        return success(buildTree(deptService.selectDeptList(dept)));
    }

    private Map<String, String> buildTree(List<SysDept> list) {
        Map<String, String> result = new HashMap<>();
        // 从班组开始往上推，最多3级
        List<SysDept> teams = list.stream().filter(x -> StrUtil.equals(x.getDeptType(), DeptTypeEnum.TEAMS.getCode())).collect(Collectors.toList());
        if (CollectionUtil.isEmpty(teams)) {
            return result;
        }
        teams.forEach(team -> {
            String val = team.getDeptId().toString();
            StringBuffer label = new StringBuffer(team.getDeptName());
            if (StrUtil.isNotBlank(team.getAncestors())) {
                String[] splits = team.getAncestors().split(",");
                // splits 去掉 第一个元素，并且反转
                List<String> reverse = Arrays.stream(splits).skip(1).collect(Collectors.toList());
                // reverse 元素反转
                Collections.reverse(reverse);
                reverse.forEach(parent -> {
                    SysDept department = list.stream().filter(x -> StrUtil.equals(parent, x.getDeptId().toString())).findFirst().orElse(new SysDept());
                    label.insert(0, department.getDeptName() + "/");
                });
            }
            result.put(val, label.toString());
        });
        return result;
    }

    /**
     * 查询部门负责人
     */
    @GetMapping(value = "/deptLeader/{deptId}")
    public AjaxResult deptLeader(@PathVariable Long deptId) {
        return success(deptService.deptLeader(deptId));
    }

    /**
     * 查询部门指定角色人员
     */
    @PostMapping(value = "/deptRole/{deptId}")
    public AjaxResult deptRole(@PathVariable Long deptId, @RequestBody List<String> roleKeyList) {
        return success(deptService.deptRole(deptId, roleKeyList));
    }
}
